--- ngx_http_auth_request_module.c.orig	2012-02-18 08:44:35.000000000 -0500
+++ ngx_http_auth_request_module.c	2012-02-18 08:44:37.000000000 -0500
@@ -158,6 +158,29 @@
             return ctx->status;
         }

+        if (ctx->status == NGX_HTTP_MOVED_TEMPORARILY) {
+            sr = ctx->subrequest;
+
+            h = sr->headers_out.location;
+
+            if (!h && sr->upstream) {
+                h = sr->upstream->headers_in.location;
+            }
+
+            if (h) {
+                ho = ngx_list_push(&r->headers_out.headers);
+                if (ho == NULL) {
+                    return NGX_ERROR;
+                }
+
+                *ho = *h;
+
+                r->headers_out.location = ho;
+            }
+
+            return ctx->status;
+        }
+
         if (ctx->status >= NGX_HTTP_OK
             && ctx->status < NGX_HTTP_SPECIAL_RESPONSE)
         {